// The pins for connecting the RGB LED
#define pinR 11
#define pinG 10
#define pinB 9

// The variables for the 2 byte protocol handling
byte cmdIn=0,dtaIn=0;
bool cmdOk=false,dtaOk=false;

// The "helper" function which replaces the map() function here
byte upscale(byte in) {
  in &= 0x7F;  // make sure we have a 7bit input (0-127) to prevent overflow
  return (in << 1) | (in >> 6);  // do the magic ;-)
}

void setup() {
  // put your setup code here, to run once:
  Serial.begin(9600);
}

void loop() {
  // put your main code here, to run repeatedly:
  if (Serial.available()) {
    byte tmp = Serial.read();
    if (tmp > 127) {  // it's a new command byte and we have to wait for a data byte
      cmdIn = tmp;
      cmdOk = true;
      dtaOk = false;
    } else {  // it's a data byte 
      if(cmdOk){  // we will only take it into account when there was a command byte before
        dtaIn=tmp;
        dtaOk = true;
      }
    }
  }
  if(cmdOk && dtaOk){
    switch (cmdIn) {
      case 129:  // command byte for red
        analogWrite(pinR,upscale(dtaIn));
        break;
      case 130:  // command byte for green
        analogWrite(pinG,upscale(dtaIn));
        break;
      case 131:  // command byte for blue
        analogWrite(pinB, upscale(dtaIn));
    }
    cmdOk=false; // reset everything
    dtaOk=false;
  }
}
